#include <QApplication>
#include "config.hpp"
#include "trayer.hpp"
#include "weatherinfo.hpp"
#include "winman.hpp"

#ifdef WIN32
#define __USE_WINDOWS__
#endif
#ifdef WIN64
#ifndef __USE_WINDOWS__
#define __USE_WINDOWS__
#endif
#endif

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    app.setQuitOnLastWindowClosed(false);

    QString path = app.applicationFilePath();
#ifdef __USE_WINDOWS__
    path = path.left(path.size() - 4);
#endif
    path += ".ini";
    config cfg(app.applicationName(), path);
    if(cfg.id == 0ULL) return -1;

    WinMan wm(cfg);
    trayer te(app.applicationName(), cfg, wm);

    WeatherInfo in(te);
    in.GetData(cfg);

    return app.exec();
}
