#ifndef WINMAN_HPP
#define WINMAN_HPP

#include <QCloseEvent>
#include <QCursor>
#include <QTimer>
#include <QWidget>
#include "config.hpp"

class WinMan;
class WeatherInfo;
class Widget : public QWidget {
    Q_OBJECT
    QTimer timer;
    WinMan &wm;
    void closeEvent(QCloseEvent *event);
public:
    Widget(int time, WinMan &man, QWidget *parent = 0);
public slots:
    void winout() {
        QCursor cursor;
        if(cursor.pos().x() < this->pos().x() ||
                cursor.pos().x() > (this->pos().x() + this->width()) ||
                cursor.pos().y() < this->pos().y() ||
                cursor.pos().y() > (this->pos().y() + this->height()))
            this->close();
    };
};

class WinMan : public QObject {
    Q_OBJECT
private:
    Widget *win;
    config &conf;
public:
    void create() {
        if(win == nullptr) {
            win = new Widget(conf.timeout, *this);
        }
        win->show();
    };

    void destroy() {
        delete win;
        win = nullptr;
    };

    void show(WeatherInfo *wi);
    WinMan(config &cfg) : win(nullptr), conf(cfg) { };
};

#endif // WINMAN_HPP
