#include <QHBoxLayout>
#include <QObject>
#include <QVBoxLayout>
#include "configwin.hpp"
#include "userdef.hpp"

ConfigWin::ConfigWin(QString &path, QString &Name, QWidget *parent)
    : QMainWindow(parent),
      setting(new QSettings(path, QSettings::IniFormat)),
      AppName(Name)
{
    this->setFixedSize(WinWidth, WinHeight);
}

void ConfigWin::addWidgets(CityList &list)
{
    citylist = &list;
    QSharedPointer<QList<QString>> country = citylist->GetList();
for(QString str : *country) {
        cbc.addItem(str);
    }

    QHBoxLayout *bcb = new QHBoxLayout;
    QHBoxLayout *lbb = new QHBoxLayout;
    QHBoxLayout *lbt = new QHBoxLayout;
    QHBoxLayout *lbe = new QHBoxLayout;
    QHBoxLayout *lbs = new QHBoxLayout;
    QVBoxLayout *vbox = new QVBoxLayout;
    QWidget *wm = new QWidget;

    lbc.setText(tr("Country:"));
    lbn.setText(tr("City:"));
    bcb->addWidget(&lbc);
    bcb->addWidget(&cbc);
    bcb->addWidget(&lbn);
    bcb->addWidget(&cbn);

    lbci.setText(tr("City Information:"));
    lbb->addWidget(&lbci);
    lbb->addWidget(&cbci);

    lblang.setText(tr("Language:"));
    lbtemp.setText(tr("Temperature:"));
    lbt->addWidget(&lblang);
    lbt->addWidget(&cblang);
    lbt->addWidget(&lbtemp);
    lbt->addWidget(&cbtemp);
    for(int i=0; i != LangCount; i++) {
        cblang.addItem(WeatherLanguage[i][0]);
    }
    for(int i=0; i != TempTypeCount; i++) {
        cbtemp.addItem(TemperatureType[i][0]);
    }

    lbFreq.setText(tr("Update Frequency(min):"));
    lbClose.setText(tr("AutoCloseWindow(s):"));
    lbe->addWidget(&lbFreq);
    lbe->addWidget(&UpdateFreq);
    lbe->addWidget(&lbClose);
    lbe->addWidget(&AutoClose);

    lbAPPID.setText(tr("APPID:"));
    Submit.setText(tr("Submit"));
    lbs->addWidget(&lbAPPID);
    lbs->addWidget(&APPID);
    lbs->addWidget(&Submit);

    vbox->addLayout(bcb);
    vbox->addLayout(lbb);
    vbox->addLayout(lbt);
    vbox->addLayout(lbe);
    vbox->addLayout(lbs);
    wm->setLayout(vbox);
    this->setCentralWidget(wm);

    QObject::connect(&cbc, SIGNAL(currentIndexChanged(int)),
                     this, SLOT(UpdateCBN(int)));
    QObject::connect(&cbn, SIGNAL(currentIndexChanged(int)),
                     this, SLOT(UpdateLBCI(int)));
    QObject::connect(&Submit, SIGNAL(released()),
                     this, SLOT(SubmitData()));

    return;
}

ConfigWin::~ConfigWin()
{

}

void ConfigWin::UpdateCBN(int idx)
{
    QString str = cbc.itemText(idx);
    QSharedPointer<QList<QString>> name = citylist->GetList(str);

    cbn.clear();
for(QString str : *name) {
        cbn.addItem(str);
    }
}

void ConfigWin::UpdateLBCI(int idx)
{
    QString str = cbn.itemText(idx);
    QString cbctext = cbc.currentText();
    QString cbntext = cbn.currentText();
    cbntext.replace("\'", "\'\'");
    info = citylist->GetList(cbctext, cbntext);
    cbci.clear();
for(QSharedPointer<CityInfo> swap: *info) {
        QString text;
        text = tr("CityID:%1 Longitude:%2 Latitude:%3")
               .arg(swap->CityID).arg(swap->coord_lon).arg(swap->coord_lat);
        cbci.addItem(text);
    }

}

void ConfigWin::SubmitData()
{
    int idx = cbci.currentIndex();
    if(idx == -1) return;
    QString id = APPID.text();
    if(id.length() == 0)  return;
    int freq = UpdateFreq.text().toInt();
    int close = AutoClose.text().toInt();

    setting->beginGroup(AppName);

    QSharedPointer<CityInfo> io = info->at(idx);
    setting->setValue("id", io->CityID);
    setting->setValue("lang",
                      WeatherLanguage[cblang.currentIndex()][1]);
    setting->setValue("units",
                      TemperatureType[cbtemp.currentIndex()][1]);
    setting->setValue("appid", id);
    setting->setValue("freq", freq);
    setting->setValue("timeout", close);

    setting->endGroup();
    this->close();
}
